/*
 * Blockdaemon REST API
 *
 * Blockdaemon REST API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://docs.blockdaemon.com/reference/rest-api-overview)  ### Currently supported protocols:  * algorand   * mainnet * avalanche    * mainnet-c/testnet-c * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/holesky/sepolia * fantom   * mainnet/testnet * litecoin   * mainnet/testnet * near   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet/amoy * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * tron   * mainnet/nile * xrp   * mainnet  ### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// TxOutputResponseMeta The meta details of the transaction.
type TxOutputResponseMeta struct {
	// A list of addresses.
	Addresses *[]string `json:"addresses,omitempty"`
	// The index number.
	Index *int32 `json:"index,omitempty"`
	// The script.
	Script *string `json:"script,omitempty"`
	// The script type.
	ScriptType *string `json:"script_type,omitempty"`
}

// NewTxOutputResponseMeta instantiates a new TxOutputResponseMeta object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTxOutputResponseMeta() *TxOutputResponseMeta {
	this := TxOutputResponseMeta{}
	return &this
}

// NewTxOutputResponseMetaWithDefaults instantiates a new TxOutputResponseMeta object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTxOutputResponseMetaWithDefaults() *TxOutputResponseMeta {
	this := TxOutputResponseMeta{}
	return &this
}

// GetAddresses returns the Addresses field value if set, zero value otherwise.
func (o *TxOutputResponseMeta) GetAddresses() []string {
	if o == nil || o.Addresses == nil {
		var ret []string
		return ret
	}
	return *o.Addresses
}

// GetAddressesOk returns a tuple with the Addresses field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxOutputResponseMeta) GetAddressesOk() (*[]string, bool) {
	if o == nil || o.Addresses == nil {
		return nil, false
	}
	return o.Addresses, true
}

// HasAddresses returns a boolean if a field has been set.
func (o *TxOutputResponseMeta) HasAddresses() bool {
	if o != nil && o.Addresses != nil {
		return true
	}

	return false
}

// SetAddresses gets a reference to the given []string and assigns it to the Addresses field.
func (o *TxOutputResponseMeta) SetAddresses(v []string) {
	o.Addresses = &v
}

// GetIndex returns the Index field value if set, zero value otherwise.
func (o *TxOutputResponseMeta) GetIndex() int32 {
	if o == nil || o.Index == nil {
		var ret int32
		return ret
	}
	return *o.Index
}

// GetIndexOk returns a tuple with the Index field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxOutputResponseMeta) GetIndexOk() (*int32, bool) {
	if o == nil || o.Index == nil {
		return nil, false
	}
	return o.Index, true
}

// HasIndex returns a boolean if a field has been set.
func (o *TxOutputResponseMeta) HasIndex() bool {
	if o != nil && o.Index != nil {
		return true
	}

	return false
}

// SetIndex gets a reference to the given int32 and assigns it to the Index field.
func (o *TxOutputResponseMeta) SetIndex(v int32) {
	o.Index = &v
}

// GetScript returns the Script field value if set, zero value otherwise.
func (o *TxOutputResponseMeta) GetScript() string {
	if o == nil || o.Script == nil {
		var ret string
		return ret
	}
	return *o.Script
}

// GetScriptOk returns a tuple with the Script field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxOutputResponseMeta) GetScriptOk() (*string, bool) {
	if o == nil || o.Script == nil {
		return nil, false
	}
	return o.Script, true
}

// HasScript returns a boolean if a field has been set.
func (o *TxOutputResponseMeta) HasScript() bool {
	if o != nil && o.Script != nil {
		return true
	}

	return false
}

// SetScript gets a reference to the given string and assigns it to the Script field.
func (o *TxOutputResponseMeta) SetScript(v string) {
	o.Script = &v
}

// GetScriptType returns the ScriptType field value if set, zero value otherwise.
func (o *TxOutputResponseMeta) GetScriptType() string {
	if o == nil || o.ScriptType == nil {
		var ret string
		return ret
	}
	return *o.ScriptType
}

// GetScriptTypeOk returns a tuple with the ScriptType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxOutputResponseMeta) GetScriptTypeOk() (*string, bool) {
	if o == nil || o.ScriptType == nil {
		return nil, false
	}
	return o.ScriptType, true
}

// HasScriptType returns a boolean if a field has been set.
func (o *TxOutputResponseMeta) HasScriptType() bool {
	if o != nil && o.ScriptType != nil {
		return true
	}

	return false
}

// SetScriptType gets a reference to the given string and assigns it to the ScriptType field.
func (o *TxOutputResponseMeta) SetScriptType(v string) {
	o.ScriptType = &v
}

func (o TxOutputResponseMeta) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Addresses != nil {
		toSerialize["addresses"] = o.Addresses
	}
	if o.Index != nil {
		toSerialize["index"] = o.Index
	}
	if o.Script != nil {
		toSerialize["script"] = o.Script
	}
	if o.ScriptType != nil {
		toSerialize["script_type"] = o.ScriptType
	}
	return json.Marshal(toSerialize)
}

type NullableTxOutputResponseMeta struct {
	value *TxOutputResponseMeta
	isSet bool
}

func (v NullableTxOutputResponseMeta) Get() *TxOutputResponseMeta {
	return v.value
}

func (v *NullableTxOutputResponseMeta) Set(val *TxOutputResponseMeta) {
	v.value = val
	v.isSet = true
}

func (v NullableTxOutputResponseMeta) IsSet() bool {
	return v.isSet
}

func (v *NullableTxOutputResponseMeta) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTxOutputResponseMeta(val *TxOutputResponseMeta) *NullableTxOutputResponseMeta {
	return &NullableTxOutputResponseMeta{value: val, isSet: true}
}

func (v NullableTxOutputResponseMeta) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTxOutputResponseMeta) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
